WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Member Functions | List of all members
winstd::com_obj< T > Class Template Reference
COM object management

COM object wrapper template. More...

`#include <COM.h>`

Inheritance diagram for winstd::com_obj< T >:

## Public Member Functions
| com_obj (_In_ REFCLSID rclsid, _In_opt_ LPUNKNOWN pUnkOuter=NULL, DWORD dwClsContext=CLSCTX_ALL)
| Constructs a new object and creates a new class with it. More...
template<class _Other >
| com_obj (_In_ _Other *other)
| Queries the object for another interface and creates new class with it. More...
template<class _Other >
| com_obj (_In_ com_obj< _Other > &other)
| Queries the object for another interface and creates new class with it. More...
virtual | ~com_obj ()
| Releases object.
HRESULT | create (_In_ REFCLSID rclsid, _In_opt_ LPUNKNOWN pUnkOuter=NULL, _In_ DWORD dwClsContext=CLSCTX_ALL)
| Creates a new object. More...
template<class _Other >
HRESULT | query_interface (_Out_ _Other **h) const
| Queries the object for another interface. More...
template<class _Other >
HRESULT | query_interface (_Out_ com_obj< _Other > &h) const
| Queries the object for another interface. More...
Public Member Functions inherited from winstd::dplhandle< T *, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| dplhandle (_In_ const dplhandle< handle_type, INVAL > &h) noexcept
| Copy constructor. More...
| dplhandle (_Inout_ dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
dplhandle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
dplhandle< handle_type, INVAL > & | operator= (_In_ const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object. More...
dplhandle< handle_type, INVAL > & | operator= (_Inout_ dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object. More...
handle_type | duplicate () const
| Duplicates and returns a new object handle. More...
bool | attach_duplicated (_In_opt_ handle_type h)
| Duplicates an object handle and sets a new object handle. More...
Public Member Functions inherited from winstd::handle< T *, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Releases the object by decrementing reference counter. More...
handle_type | duplicate_internal (_In_ handle_type h) const noexcept override
| Duplicates the object by incrementing the reference counter. More...
virtual handle_type | duplicate_internal (_In_ handle_type h) const noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object handle duplication. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members
Public Types inherited from winstd::handle< T *, INVAL >
typedef T * | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< T *, INVAL >
static const T * | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< T *, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

template<class T>
class winstd::com_obj< T >

COM object wrapper template.

## Constructor & Destructor Documentation

## ◆ com_obj() [1/3]

template<class T >

winstd::com_obj< T >::com_obj | ( | _In_ REFCLSID | rclsid,
|  | _In_opt_ LPUNKNOWN | pUnkOuter = `NULL`,
|  | DWORD | dwClsContext = `CLSCTX_ALL`
| ) |  |
| inline

Constructs a new object and creates a new class with it.

See also
  CoCreateInstance function

## ◆ com_obj() [2/3]

template<class T >
template<class _Other >

winstd::com_obj< T >::com_obj | ( | _In_ _Other * | other | ) |
| inline

Queries the object for another interface and creates new class with it.

See also
  IUnknown::QueryInterface method

## ◆ com_obj() [3/3]

template<class T >
template<class _Other >

winstd::com_obj< T >::com_obj | ( | _In_ com_obj< _Other > & | other | ) |
| inline

Queries the object for another interface and creates new class with it.

See also
  IUnknown::QueryInterface method

## Member Function Documentation

## ◆ create()

template<class T >

HRESULT winstd::com_obj< T >::create | ( | _In_ REFCLSID | rclsid,
|  | _In_opt_ LPUNKNOWN | pUnkOuter = `NULL`,
|  | _In_ DWORD | dwClsContext = `CLSCTX_ALL`
| ) |  |
| inline

Creates a new object.

See also
  CoCreateInstance function

## ◆ duplicate_internal()

template<class T >

handle_type winstd::com_obj< T >::duplicate_internal | ( | _In_ handle_type | h | ) | const
| inline override protected virtual noexcept

Duplicates the object by incrementing the reference counter.

See also
  IUnknown::AddRef method

Parameters

  [in] | h | Object handle of existing object

Returns
  Duplicated object handle

Implements winstd::dplhandle< T *, NULL >.

## ◆ free_internal()

template<class T >

void winstd::com_obj< T >::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Releases the object by decrementing reference counter.

See also
  IUnknown::Release method

Implements winstd::handle< T *, INVAL >.

## ◆ query_interface() [1/2]

template<class T >
template<class _Other >

HRESULT winstd::com_obj< T >::query_interface | ( | _Out_ _Other ** | h | ) | const
| inline

Queries the object for another interface.

See also
  IUnknown::QueryInterface method

## ◆ query_interface() [2/2]

template<class T >
template<class _Other >

HRESULT winstd::com_obj< T >::query_interface | ( | _Out_ com_obj< _Other > & | h | ) | const
| inline

Queries the object for another interface.

See also
  IUnknown::QueryInterface method

The documentation for this class was generated from the following file:

- include/WinStd/COM.h